﻿using System;
using System.Collections.Generic;
//using System.Linq;
using System.Text;
namespace LeMAKSoftBSS
{
    public class SMS
    {
        #region Declarations
            private string _username;
            private string _password;

            public  string from { get; set; }
            public string smsBody { get; set; }
            public List<string> to { get; set; }
        #endregion


        #region Constructors

        public SMS(string userName, string password)
            {
                if (string.IsNullOrWhiteSpace(userName) || string.IsNullOrWhiteSpace(password) || userName.Length < 4 || password.Length < 4)
                    throw new Exception("The user name or the password is incorrect.");

                this._username = userName;
                this._password = password;
            }

        public SMS(string userName, string password,string from,List<string> to, string smsBody)
        {           
            this._username = userName;
            this._password = password;
            this.from = from;
            this.to = to;
            this.smsBody = smsBody;
        }
        /***** The best constructor *******/
            public SMS(string userName, string password, string from, string to, string smsBody)
            {                     
                this._username = userName;
                this._password = password;
                this.from = from;
                this.to = to.Split(new char[] { ',', '|' }, StringSplitOptions.RemoveEmptyEntries).ToList();
                this.smsBody = smsBody;
            }
        /***** The best constructor *******/

        public SMS(string userName, string password, string from, string[] to, string smsBody)
        {
            this._username = userName;
            this._password = password;
            this.from = from;
            this.to = to.ToList();
            this.smsBody = smsBody;
        }
        #endregion


        #region Send SMS Methods
        public string sendSMS(string from, string[] to, string smsBody)
         {
                int lenghtTo = to.Length;

                if (from.Length > 11) throw new Exception("The sender name is too long. 11 characters max.");
                if (lenghtTo <= 0) throw new Exception("The recipients list is empty.");


                string listStrings = "";
                for (int i = 0; i < lenghtTo; i++)
                {
                    if (i == (lenghtTo - 1)) listStrings += to[i];
                    else listStrings += to[i] + ",";
                }



                return coreSendSMS(from, listStrings, smsBody, "216.58.206.46");
        }
        public string sendSMS(string from, List<string> to, string smsBody)
        {
            int lenghtTo = to.Count;

            if (from.Length > 11) throw new Exception("The sender name is too long. 11 characters max.");
            if (lenghtTo <= 0) throw new Exception("The recipients list is empty.");

            string listStrings = "";
            for (int i = 0; i < lenghtTo; i++)
            {
                if (i == (lenghtTo - 1)) listStrings += to[i];
                else listStrings += to[i] + ",";
            }





            return coreSendSMS(from, listStrings, smsBody, "216.58.206.46");
        }
        public string sendSMS(string from, string to, string smsBody)
        {
            string[] tmpTo = to.Split(new char[] {',','|' },StringSplitOptions.RemoveEmptyEntries);

            int lenghtTo = tmpTo.Length;

            if (from.Length > 11) throw new Exception("The sender name is too long. 11 characters max.");
            if (lenghtTo <= 0) throw new Exception("The recipients list is empty.");

            string listStrings = "";
            for (int i = 0; i < lenghtTo; i++)
            {
                if (i == (lenghtTo - 1)) listStrings += tmpTo[i];
                else listStrings += tmpTo[i] + ",";
            }





            return coreSendSMS(from, to, smsBody, "216.58.206.46"); 
        }
        
        public string sendSMS()
        {
            int lenghtTo = this.to.Count;

            if (this.from.Length > 11) throw new Exception("The sender name is too long. 11 characters max.");
            if (lenghtTo <= 0) throw new Exception("The recipients list is empty.");

            string listStrings = "";
            for (int i = 0; i < lenghtTo; i++)
            {
                if (i == (lenghtTo - 1)) listStrings += to[i];
                else listStrings += to[i] + ",";
            }





            return coreSendSMS(from, listStrings, this.smsBody, "216.58.206.46");
        }

        #endregion


        #region Core SMS Sending Method
        private string coreSendSMS(string from, string  to, string smsBody, string ip)
        {
            try
            {    
              
                
                return new LeMAKSoftSMSGW().EnvoiMsg(this._username, this._password, from, to, smsBody, ip);              
                 
    
            }
            catch (Exception ex)
            {
                return ex.Message;
                // return "ERRDLLOPSENDSMS";
            }

        }

        #endregion
        

        #region Check Balance Methods
        public string checkBalance()
            {
                if (string.IsNullOrWhiteSpace(this._username) || string.IsNullOrWhiteSpace(this._password) || this._username.Length < 4 || this._password.Length < 4)
                    throw new Exception("The user name or the password is incorrect.");

                try
                {


                    return new LeMAKSoftSMSGW().ConsulterCredit(this._username, this._password, "216.58.206.46");


                }          
                catch (Exception ex)
                {
                    return "ERRDLLOPCHKBAL";
                }
            }

        #endregion


        #region Change Password Methods
        public string changePassword(string newPassword)
            {
                if (string.IsNullOrWhiteSpace(this._username) || string.IsNullOrWhiteSpace(this._password) || this._username.Length < 4 || this._password.Length < 4)
                    throw new Exception("The user name or the password is incorrect.");
                System.Text.RegularExpressions.Regex r = new System.Text.RegularExpressions.Regex(@"^(?=.*[a-z])(?=.*[A-Z])(?=.*\d)(?=.*[^\da-zA-Z]).{8,15}$");
                if (r.IsMatch(newPassword))
                    throw new Exception("The user name or the password is incorrect.");


                try
                {

                    return new LeMAKSoftSMSGW().ChangePassWord(this._username, this._password, newPassword, "216.58.206.46");

                }                
                catch (Exception ex)
                {
                    return "ERRDLLOPCHGPWD";
                }
            }
        #endregion



    }
}
